import { createRouter, createWebHistory } from 'vue-router';
import { Auth } from '../connectors/auth.connector';

const routes = [
  {
    path: '/',
    compoent: () => import('@/layouts/default/Default.vue'),
    children: [
      {
        path: '/',
        name: '',
        component: () => import('@/views/Login.vue'),
      }
    ],
  },
  {
    path: '/login',
    compoent: () => import('@/layouts/default/Default.vue'),
    children: [
      {
        path: '/login',
        name: 'Login',
        component: () => import('@/views/Login.vue'),
      }
    ],
  },
  {
    path: '/register',
    compoent: () => import('@/layouts/default/Default.vue'),
    children: [
      {
        path: '/register',
        name: 'Register',
        component: () => import('@/views/Register.vue'),
      }
    ],
  },
  {
    path: '/search',
    component: () => import('@/layouts/default/Default.vue'),
    children: [
      {
        path: '/search',
        name: 'Search',
        // route level code-splitting
        // this generates a separate chunk (Home-[hash].js) for this route
        // which is lazy-loaded when the route is visited.
        component: () => import('@/views/Search.vue'),
      },
    ],
  },
  {
    path: '/favourites',
    component: () => import('@/layouts/default/Default.vue'),
    children: [
      {
        path: '/favourites',
        name: 'Favourites',
        // route level code-splitting
        // this generates a separate chunk (Home-[hash].js) for this route
        // which is lazy-loaded when the route is visited.
        component: () => import('@/views/Favourites.vue'),
      },
    ],
  },
];

const router = createRouter({
  history: createWebHistory(process.env.BASE_URL),
  routes,
});

router.beforeEach(async (to) => {
  const me = await Auth.Me();

  if (!me && to.name !== 'Login' && to.name !== 'Register') {
    return { name: 'Login' };
  }

  if (me && to.name === 'Login') {
    console.log('should return to search');
    return { name: 'Search' };
  }

  if (me && to.name === 'Register') {
    return { name: 'Search' };
  }
});

export default router;
